open Printf

let add x y = x + y

let add_up x y f = f (x + y)
let upcall d = fun d -> printf "ML Upcall '%d'\n" d; flush stdout
let print s = printf "Printing '%s'\n" s; flush stdout
let news() = "String defined in ML"

type int_list = int list

let rec sum = function
  | hd :: tl ->
      (sum tl) + hd
  | [] ->
      0

let get_list() = [1; 2; 3]

let length = List.length

let comp_string s =
  if (T_pre.strcmp s "hello") = 0 then
    printf "I say hello!\n"
  else
    printf "You say '%s'\n" s;
  flush stdout

type sig_handler = int -> unit

let sig_handler s =
  printf "Got signal %d\n" s;
  flush stdout

let test_sig() =
  T_pre.signal 2 (T_pre.magic sig_handler);
  T_pre.signal 3 (Obj.magic sig_handler);
  T_pre.kill 2;
  T_pre.kill 3
